"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const Plot_1 = __importDefault(require("./Plot"));
const Axis_1 = __importDefault(require("./components/Axis"));
const Legend_1 = __importDefault(require("./components/Legend"));
const LineSeries_1 = __importDefault(require("./components/LineSeries"));
const ScatterSeries_1 = __importDefault(require("./components/ScatterSeries"));
function PlotObject({ plot: { dimentions, viewportStyle, axes, series, legend, colorScheme }, }) {
    return (react_1.default.createElement(Plot_1.default, Object.assign({ colorScheme: colorScheme, viewportStyle: viewportStyle }, dimentions),
        axes.map((props) => (react_1.default.createElement(Axis_1.default, Object.assign({ key: props.id }, props)))),
        legend !== undefined ? react_1.default.createElement(Legend_1.default, Object.assign({}, legend)) : null,
        series.map(({ type, ...props }, i) => {
            switch (type) {
                case 'line': {
                    // eslint-disable-next-line react/no-array-index-key
                    return react_1.default.createElement(LineSeries_1.default, Object.assign({ key: `lineseries-${i}` }, props));
                }
                case 'scatter': {
                    // eslint-disable-next-line react/no-array-index-key
                    return react_1.default.createElement(ScatterSeries_1.default, Object.assign({ key: `scatterseries-${i}` }, props));
                }
                default: {
                    return null;
                }
            }
        })));
}
exports.default = PlotObject;
