"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tick = exports.Ticks = void 0;
const react_1 = __importDefault(require("react"));
function Ticks(props) {
    const { show, ticks, scale, getPositions, scientific = true, ...otherProps } = props;
    if (!show)
        return null;
    const elements = ticks.map((tick) => {
        const { line, text } = getPositions(scale(tick));
        return (react_1.default.createElement(Tick, Object.assign({ key: tick, line: line, text: text }, otherProps), scientific ? tick.toExponential(2) : tick));
    });
    return react_1.default.createElement(react_1.default.Fragment, null, elements);
}
exports.Ticks = Ticks;
function Tick(props) {
    const { line: { x1: lineX1 = 0, x2: lineX2 = 0, y1: lineY1 = 0, y2: lineY2 = 0 }, text: { x1: textX1 = 0, y1: textY1 = 0 }, style, children, strokeColor = 'black', anchor = 'end', } = props;
    return (react_1.default.createElement("g", null,
        react_1.default.createElement("line", { x1: lineX1, x2: lineX2, y1: lineY1, y2: lineY2, stroke: strokeColor }),
        react_1.default.createElement("text", { x: textX1, y: textY1, textAnchor: anchor, dominantBaseline: "middle", style: { userSelect: 'none', ...style } }, children)));
}
exports.Tick = Tick;
