"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const hooks_1 = require("../../hooks");
const BottomAxis_1 = __importDefault(require("./BottomAxis"));
const LeftAxis_1 = __importDefault(require("./LeftAxis"));
const RightAxis_1 = __importDefault(require("./RightAxis"));
const TopAxis_1 = __importDefault(require("./TopAxis"));
function Axis({ id, position, min, max, padding, flip = false, 
// children props
label, fontSize = 16, labelSpace = 24, displayGridLines, labelStyle, hidden = false, tickStyle = {}, hiddenTicks, tickEmbedded, tickLength = 6, }) {
    const { dispatch } = hooks_1.useDispatchContext();
    const xY = ['top', 'bottom'].includes(position) ? 'x' : 'y';
    react_1.useEffect(() => {
        const [minPadding = 0, maxPadding = 0] = padding || [0, 0];
        if (minPadding < 0 || minPadding > 1) {
            throw new Error(`Padding ${position} (${minPadding}) is not between 0 and 1`);
        }
        if (maxPadding < 0 || maxPadding > 1) {
            throw new Error(`Padding ${position} (${maxPadding}) is not between 0 and 1`);
        }
        dispatch({
            type: 'newAxis',
            value: {
                id: id || xY,
                position,
                min,
                max,
                padding: [minPadding, maxPadding],
                flip,
            },
        });
        return () => dispatch({ type: 'removeAxis', value: { id: id || xY } });
    }, [dispatch, xY, id, position, min, max, padding, flip]);
    const childProps = {
        id: id || xY,
        displayGridLines,
        hidden,
        label,
        labelSpace,
        labelStyle,
        fontSize,
        tickStyle,
        hiddenTicks,
        tickEmbedded,
        tickLength,
    };
    switch (position) {
        case 'top':
            return react_1.default.createElement(TopAxis_1.default, Object.assign({}, childProps));
        case 'bottom':
            return react_1.default.createElement(BottomAxis_1.default, Object.assign({}, childProps));
        case 'left':
            return react_1.default.createElement(LeftAxis_1.default, Object.assign({}, childProps));
        case 'right':
            return react_1.default.createElement(RightAxis_1.default, Object.assign({}, childProps));
        default:
            return null;
    }
}
exports.default = Axis;
